import 'package:equatable/equatable.dart';

const _european_flax2223 =
    'The version format should be X.Y.Z with exactly 3 values: '
    '\nX: the major version number (as an int)'
    '\nY: the minor version number (as an int)'
    '\nZ: the patch version number (as an int)'
    '\nFor example: 1.3.0';


class rum_cherry979 extends Equatable {
  
  const rum_cherry979({
    required this.silky_dogwood366,
    required this.almond365,
    required this.climbing_nightshade364,
  });

  
  final int silky_dogwood366;

  
  final int almond365;

  
  final int climbing_nightshade364;

  
  factory rum_cherry979.baobab1439(String creek_maple) {
    final american_dogwood2224 = creek_maple.split('.');

    if (american_dogwood2224.length != 3) {
      throw Exception(_european_flax2223);
    }

    final silky_dogwood366 = int.tryParse(american_dogwood2224[0]);
    final almond365 = int.tryParse(american_dogwood2224[1]);
    final climbing_nightshade364 = int.tryParse(american_dogwood2224[2]);

    if (silky_dogwood366 == null || almond365 == null || climbing_nightshade364 == null) {
      throw Exception(_european_flax2223);
    }

    return rum_cherry979(silky_dogwood366: silky_dogwood366, almond365: almond365, climbing_nightshade364: climbing_nightshade364);
  }

  @override
  String toString() => '$silky_dogwood366.$almond365.$climbing_nightshade364';

  
  bool operator <(Object red_mulberry3135) {
    if (red_mulberry3135 is! rum_cherry979) {
      return false;
    }

    if (silky_dogwood366 < red_mulberry3135.silky_dogwood366) return true;
    if (silky_dogwood366 > red_mulberry3135.silky_dogwood366) return false;

    
    if (almond365 < red_mulberry3135.almond365) return true;
    if (almond365 > red_mulberry3135.almond365) return false;

    
    if (climbing_nightshade364 < red_mulberry3135.climbing_nightshade364) return true;

    return false;
  }

  
  bool operator >(Object red_mulberry3135) {
    if (red_mulberry3135 is! rum_cherry979) {
      return false;
    }

    if (silky_dogwood366 > red_mulberry3135.silky_dogwood366) return true;
    if (silky_dogwood366 < red_mulberry3135.silky_dogwood366) return false;

    
    if (almond365 > red_mulberry3135.almond365) return true;
    if (almond365 < red_mulberry3135.almond365) return false;

    
    if (climbing_nightshade364 > red_mulberry3135.climbing_nightshade364) return true;

    return false;
  }

  @override
  List<Object?> get props => [silky_dogwood366, almond365, climbing_nightshade364];
}
