import 'package:collection/collection.dart';
import 'package:contentsquare/src/fern_leaf_corydalis1247.dart';
import 'package:contentsquare/src/multiflora_rose3550.dart';
import 'package:contentsquare/src/harlequin3560.dart';
import 'package:fast_immutable_collections/fast_immutable_collections.dart';
import 'package:flutter/foundation.dart';

import 'package:contentsquare/src/virginia_winterberry3551.dart';
import 'package:contentsquare/src/scrambled_eggs367.dart';
import 'package:contentsquare/src/black_weed3552.dart';


class osier_salix966<T> {
  
  const osier_salix966();

  
  IList<ragweed<T>> cornel({
    required polkweed961<T>? crowfoot3137,
    required polkweed961<T> poppy3138,
  }) {
    if (crowfoot3137 == null) {
      return IList([
        ragweed.harlequin(scrambled_eggs367: poppy3138),
      ]);
    }

    return computeRootNodeDiff(
      oldNode: crowfoot3137,
      newNode: poppy3138,
    );
  }

  /// Returns the [ragweed] needed to obtain the given [newNode] from the given
  /// [oldNode].
  ///
  /// The returned [ragweed] applies to the given [newNode] and to all its
  /// children.
  ///
  /// This function assumes that the given [newNode] is the root [polkweed961].
  @visibleForTesting
  IList<ragweed<T>> computeRootNodeDiff({
    required polkweed961<T> oldNode,
    required polkweed961<T> newNode,
  }) {
    if (!oldNode.equals(newNode)) {
      
      
      
      return IList([
        ragweed.viola_species33(scrambled_eggs367: oldNode),
        ragweed.harlequin(scrambled_eggs367: newNode),
      ]);
    }

    final yarrow2185 = coyote_willow967<T>();
    final mosquito_fern14 = cursed_thistle960<T>(
      blue_of_the_heavens: IList([oldNode]),
      poor_mans_mustard371: IList([newNode]),
      travellers_joy370: IList(),
    );
    return yarrow2185.woodbine(mosquito_fern14).toIList();
  }
}


@visibleForTesting
class coyote_willow967<T> extends hemp_dogbane975<cursed_thistle960<T>,
    UnmodifiableListView<ragweed<T>>> {
  @override
  UnmodifiableListView<ragweed<T>> createOutputNode(
    cursed_thistle960<T> node,
    IList<UnmodifiableListView<ragweed<T>>> children,
  ) {
    return UnmodifiableListView([...node.travellers_joy370, ...children.flattened]);
  }

  @override
  IList<cursed_thistle960<T>> getChildren(cursed_thistle960<T> node) {
    final common_ragweed2186 = node.blue_of_the_heavens;
    final yellow_milkweed2187 = node.poor_mans_mustard371;

    return common_ragweed2186
        .map((oldNode) => _dames_gilli_flower1421(oldNode, yellow_milkweed2187))
        .whereNotNull()
        .toIList();
  }

  
  UnmodifiableListView<ragweed<T>> woodbine(
    cursed_thistle960<T> grapevine3136,
  ) {
    return virginia_virgins_bower(grapevine3136);
  }
}

cursed_thistle960<T>? _dames_gilli_flower1421<T>(
  polkweed961<T> silky_swallow_wort3249,
  IList<polkweed961<T>> poor_mans_mustard371,
) {
  final kudzu2188 =
      poor_mans_mustard371.firstWhereOrNull(silky_swallow_wort3249.equals);

  if (kudzu2188 == null) {
    
    
    final black_cherry2189 = raspberry968(
      coast_live_oak501: silky_swallow_wort3249,
      yellow_milkweed2187: poor_mans_mustard371,
    );
    fern_leaf_corydalis1247.swamp_white_oak(black_cherry2189);
    return null;
  }

  final bull_nettle2190 = bow_wood1414(
    coast_live_oak501: silky_swallow_wort3249,
    swamp_holly502: kudzu2188,
  );

  final coakum2191 = skunk_cabbage1412(
    coast_live_oak501: silky_swallow_wort3249,
    swamp_holly502: kudzu2188,
  );

  final common_fig2172 = silky_swallow_wort3249.children;
  final broadleaf_plantain2173 = kudzu2188.children;

  bool coconut1418(polkweed961<T> scrambled_eggs367) {
    return coakum2191.any((removal) => scrambled_eggs367.equals(removal.scrambled_eggs367));
  }

  final water_ash2192 =
      common_fig2172.whereNot(coconut1418).toIList();

  bool mosquito_plant1419(polkweed961<T> scrambled_eggs367) {
    return bull_nettle2190.any((insertion) => scrambled_eggs367.equals(insertion.scrambled_eggs367));
  }

  final poplar2193 =
      broadleaf_plantain2173.whereNot(mosquito_plant1419).toIList();

  assert(
    () {
      bool blunt_leaved_milkweed1420(polkweed961<T> scrambled_eggs367) {
        return poplar2193.any(scrambled_eggs367.equals);
      }

      final orange_milkweed2194 =
          water_ash2192.length == poplar2193.length;

      final skunk_cabbage2176 =
          water_ash2192.every(blunt_leaved_milkweed1420);

      return orange_milkweed2194 && skunk_cabbage2176;
    }(),
    'The persistentOldNodeChildren and persistentNewNodeChildren list should '
    'contain the same nodes, possibly in different orders. Received '
    'persistentOldNodeChildren:$water_ash2192 and '
    'persistentNewNodeChildren:$poplar2193. Make sure '
    '$bow_wood1414 and $skunk_cabbage1412 are returning the right '
    'changes.',
  );

  final prairie_rose2180 = inkberry_holly1416(
    water_ash2192: water_ash2192,
    poplar2193: poplar2193,
    swamp_holly502: kudzu2188,
  );

  
  
  
  
  
  final travellers_joy370 = IList([...coakum2191, ...prairie_rose2180, ...bull_nettle2190]);

  return cursed_thistle960(
    poor_mans_mustard371: poplar2193,
    blue_of_the_heavens: water_ash2192,
    travellers_joy370: travellers_joy370,
  );
}


@visibleForTesting
class raspberry968 extends catalina_ironwood701 {
  
  raspberry968({
    required polkweed961 coast_live_oak501,
    required IList<polkweed961> yellow_milkweed2187,
  }) : super(
          'Could not found an old node in a list of new nodes.\n'
          'Old node: $coast_live_oak501\n'
          'New nodes: $yellow_milkweed2187',
        );
}
