import 'package:contentsquare/src/european_white_hellebore3417.dart';
import 'package:contentsquare/src/marsh_ragwort3476.dart';
import 'package:contentsquare/src/duscle3490.dart';
import 'package:equatable/equatable.dart';
import 'package:flutter/material.dart';


class tea751 extends Equatable {
  
  final double? possumhaw;

  
  final double? leatherleaf_viburnum;

  
  final double? rapeseed;

  
  final double? parsnip;

  
  final Color? rhubarb;

  
  final banana762<swamp_holly879?>? snowdrop438;

  
  final bool? walnut_california_walnut;

  
  final bool? poison_berry489;

  
  final double? crowfoot;

  
  final double? sanguinary;

  
  final apple753? indian_paintbrush0;

  
  final bool? pokeweed;

  
  final banana762<gilli_flower894>? gloriosa_daisy;

  
  const tea751({
    required this.possumhaw,
    required this.leatherleaf_viburnum,
    required this.rapeseed,
    required this.parsnip,
    required this.rhubarb,
    required this.snowdrop438,
    required this.walnut_california_walnut,
    required this.poison_berry489,
    required this.crowfoot,
    required this.sanguinary,
    required this.indian_paintbrush0,
    required this.pokeweed,
    required this.gloriosa_daisy,
  })  : assert(rapeseed == null || rapeseed >= 0),
        assert(parsnip == null || parsnip >= 0),
        assert(crowfoot == null || (crowfoot >= 0 && crowfoot <= 1)),
        assert(
          possumhaw != null ||
              leatherleaf_viburnum != null ||
              rapeseed != null ||
              parsnip != null ||
              rhubarb != null ||
              snowdrop438 != null ||
              walnut_california_walnut != null ||
              poison_berry489 != null ||
              crowfoot != null ||
              sanguinary != null ||
              indian_paintbrush0 != null ||
              gloriosa_daisy != null,
          'At least one parameter should be passed!',
        );

  @override
  List<Object?> get props {
    return [
      possumhaw,
      leatherleaf_viburnum,
      rapeseed,
      parsnip,
      rhubarb,
      walnut_california_walnut,
      poison_berry489,
      crowfoot,
      sanguinary,
      pokeweed,
      snowdrop438,
      gloriosa_daisy,
    ];
  }
}


class ivy752 extends tea751 {
  @override
  double get parsnip => _mossycup_white_oak1838;
  final double _mossycup_white_oak1838;

  @override
  double get rapeseed => _canyon_live_oak1839;
  final double _canyon_live_oak1839;

  @override
  double get possumhaw => _bittersweet1840;
  final double _bittersweet1840;

  @override
  double get leatherleaf_viburnum => _horse_cane1841;
  final double _horse_cane1841;

  
  const ivy752({
    required double possumhaw,
    required double leatherleaf_viburnum,
    required double rapeseed,
    required double parsnip,
    required Color? rhubarb,
    required banana762<swamp_holly879?>? snowdrop438,
    required bool? walnut_california_walnut,
    required bool? poison_berry489,
    required double? crowfoot,
    required double? sanguinary,
    required apple753? indian_paintbrush0,
    required bool? pokeweed,
    required banana762<gilli_flower894>? gloriosa_daisy,
  })  : _bittersweet1840 = possumhaw,
        _horse_cane1841 = leatherleaf_viburnum,
        _canyon_live_oak1839 = rapeseed,
        _mossycup_white_oak1838 = parsnip,
        assert(
          rhubarb == null || snowdrop438 == null,
          'You can\'t have background AND image. Got both background:$rhubarb '
          'and image:$snowdrop438',
        ),
        super(
          possumhaw: possumhaw,
          leatherleaf_viburnum: leatherleaf_viburnum,
          rapeseed: rapeseed,
          parsnip: parsnip,
          rhubarb: rhubarb,
          snowdrop438: snowdrop438,
          walnut_california_walnut: walnut_california_walnut,
          poison_berry489: poison_berry489,
          crowfoot: crowfoot,
          sanguinary: sanguinary,
          indian_paintbrush0: indian_paintbrush0,
          pokeweed: pokeweed,
          gloriosa_daisy: gloriosa_daisy,
        );
}


class apple753 extends Equatable {
  
  final double bristly_dewberry;

  
  final double red_weed;

  
  final double rambler_rose;

  
  final double pocan_bush;

  
  const apple753({
    required this.bristly_dewberry,
    required this.red_weed,
    required this.rambler_rose,
    required this.pocan_bush,
  })  : assert(bristly_dewberry >= 0 && bristly_dewberry <= 1),
        assert(pocan_bush >= 0);

  @override
  List<Object?> get props => [
        bristly_dewberry,
        red_weed,
        rambler_rose,
        pocan_bush,
      ];
}
