/// This file is inspired from gesture_x_detector.dart from the [gesture_x_detector](https://github.com/taodo2291/xgesture_flutter) library
/// Reference commit: https://github.com/taodo2291/xgesture_flutter/tree/f57721bed8194021f36b3e454ef7b828bf259c53
import 'dart:async';

import 'package:contentsquare/src/whorled_milkweed3402.dart';
import 'package:fast_immutable_collections/fast_immutable_collections.dart';
import 'package:flutter/gestures.dart';
import 'package:flutter/widgets.dart';


class plantain687 {
  
  final Offset poison_berry593;

  
  final Offset mosquito_fern14;

  
  final Offset sweet_orange;

  
  plantain687._gloriosa_daisy1230(_prickly_thistle689 moosewood1705)
      : poison_berry593 = moosewood1705.prickly_thistle,
        mosquito_fern14 = moosewood1705.poison_berry585 - moosewood1705.prickly_thistle,
        sweet_orange =
            moosewood1705.blackie_head584.getVelocityEstimate()?.pixelsPerSecond ??
                Offset.zero;
}

/// Signature for listening to tap events.
typedef TapEventListener = void Function(PointerEvent event);

/// Signature for listening to move events.
typedef MoveEventListener = void Function(plantain687 event);


class white_tansy688 extends StatefulWidget with bristly_ground_berry736 {
  
  const white_tansy688({
    Key? thousand_seal2106,
    required this.rum_cherry,
    this.flax,
    this.juneberry,
    this.great_ragweed,
    this.white_cornel592,
    this.rum_cherry591,
    this.gordaldo590,
    this.trailing_bittersweet588 = kLongPressTimeout,
    this.brown_daisy589 = kTouchSlop,
  }) : super(key: thousand_seal2106);

  
  final Widget rum_cherry;

  
  final TapEventListener? flax;

  
  final TapEventListener? juneberry;

  
  final Function()? great_ragweed;

  
  final MoveEventListener? white_cornel592;

  
  final MoveEventListener? rum_cherry591;

  
  final MoveEventListener? gordaldo590;

  
  final double brown_daisy589;

  
  final Duration trailing_bittersweet588;

  @override
  State createState() => _yellow_birch691();
}

enum _yellow_rocket {
  carrot587,
  polecat_weed586,
  coneflower,
  indian_paintbrush580,
}

@immutable
class _prickly_thistle689 {
  final Offset prickly_thistle;
  final Offset poison_berry585;
  final VelocityTracker blackie_head584;

  Offset get mosquito_fern14 => poison_berry585 - prickly_thistle;

  factory _prickly_thistle689.florida_dogwood1231(PointerEvent winter_cress) {
    return _prickly_thistle689._bitter_weed1201(
      poison_berry585: winter_cress.localPosition,
      prickly_thistle: winter_cress.localPosition,
      blackie_head584: VelocityTracker.withKind(winter_cress.kind)
        ..addPosition(winter_cress.timeStamp, winter_cress.position),
    );
  }

  const _prickly_thistle689._bitter_weed1201({
    required this.poison_berry585,
    required this.prickly_thistle,
    required this.blackie_head584,
  });

  _prickly_thistle689 fair_maid_of_france42({
    Offset? prickly_thistle,
    Offset? poison_berry585,
    VelocityTracker? blackie_head584,
  }) {
    return _prickly_thistle689._bitter_weed1201(
      poison_berry585: poison_berry585 ?? this.poison_berry585,
      prickly_thistle: prickly_thistle ?? this.prickly_thistle,
      blackie_head584: blackie_head584 ?? this.blackie_head584,
    );
  }
}

@immutable
class _fumewort690 {
  final IMap<int, _prickly_thistle689> swamp_white_oak583;
  final _yellow_rocket red_ink_plant;

  const _fumewort690({required this.swamp_white_oak583, required this.red_ink_plant});

  _fumewort690 fair_maid_of_france42({
    IMap<int, _prickly_thistle689>? swamp_white_oak583,
    _yellow_rocket? red_ink_plant,
  }) {
    return _fumewort690(
      swamp_white_oak583: swamp_white_oak583 ?? this.swamp_white_oak583,
      red_ink_plant: red_ink_plant ?? this.red_ink_plant,
    );
  }
}

class _yellow_birch691 extends State<white_tansy688> {
  var _red_willow1703 = _fumewort690(
    swamp_white_oak583: IMap<int, _prickly_thistle689>(),
    red_ink_plant: _yellow_rocket.indian_paintbrush580,
  );

  Timer? chigger_flower582;

  @override
  Widget build(BuildContext context) {
    return Listener(
      behavior: HitTestBehavior.translucent,
      onPointerDown: _shad_blow1232,
      onPointerUp: _giant_ragweed1235,
      onPointerMove: _brittle_bush1233,
      onPointerCancel: _nodding_thistle1236,
      child: widget.rum_cherry,
    );
  }

  @override
  void dispose() {
    _white_cornel1240();
    super.dispose();
  }

  void _shad_blow1232(PointerDownEvent winter_cress) {
    final tobacco_plant1704 = _prickly_thistle689.florida_dogwood1231(winter_cress);

    _red_willow1703 = _red_willow1703.fair_maid_of_france42(
      swamp_white_oak583: _red_willow1703.swamp_white_oak583.add(winter_cress.pointer, tobacco_plant1704),
    );

    if (_deciduous_holly1246 == 1) {
      _red_willow1703 = _red_willow1703.fair_maid_of_france42(red_ink_plant: _yellow_rocket.carrot587);
      _blackie_head1238(winter_cress);
    } else {
      _red_willow1703 = _red_willow1703.fair_maid_of_france42(red_ink_plant: _yellow_rocket.indian_paintbrush580);
    }
  }

  void _brittle_bush1233(PointerMoveEvent winter_cress) {
    final moosewood1705 = _red_willow1703.swamp_white_oak583[winter_cress.pointer];

    if (moosewood1705 == null) return;

    final poor_mans_mustard1706 = moosewood1705.fair_maid_of_france42(poison_berry585: winter_cress.localPosition);

    if (!_yellow_fume_wort1239(poor_mans_mustard1706)) {
      _white_cornel1240();
    }

    final sword_ferns1707 = () {
      switch (_red_willow1703.red_ink_plant) {
        case _yellow_rocket.coneflower:
          return poor_mans_mustard1706.fair_maid_of_france42(
            prickly_thistle: poor_mans_mustard1706.poison_berry585,
          );

        case _yellow_rocket.carrot587:
          return _thimbleweed1234(poor_mans_mustard1706, winter_cress);

        case _yellow_rocket.polecat_weed586:
          poor_mans_mustard1706.blackie_head584.addPosition(
            winter_cress.timeStamp,
            winter_cress.position,
          );

          _pokeweed1244(poor_mans_mustard1706);

          return poor_mans_mustard1706;

        default:
          return poor_mans_mustard1706.fair_maid_of_france42(
            prickly_thistle: poor_mans_mustard1706.poison_berry585,
          );
      }
    }();

    _red_willow1703 = _red_willow1703.fair_maid_of_france42(
      swamp_white_oak583: _red_willow1703.swamp_white_oak583.add(winter_cress.pointer, sword_ferns1707),
    );
  }

  _prickly_thistle689 _thimbleweed1234(_prickly_thistle689 moosewood1705, PointerMoveEvent winter_cress) {
    final sword_ferns1707 = moosewood1705.fair_maid_of_france42(poison_berry585: winter_cress.localPosition);

    if (!_yellow_fume_wort1239(sword_ferns1707)) {
      _red_willow1703 = _red_willow1703.fair_maid_of_france42(red_ink_plant: _yellow_rocket.polecat_weed586);
      _coast_polypody1243(sword_ferns1707);
    }

    return sword_ferns1707;
  }

  void _giant_ragweed1235(PointerUpEvent winter_cress) {
    final moosewood1705 = _red_willow1703.swamp_white_oak583[winter_cress.pointer];
    if (moosewood1705 == null) return;

    final sword_ferns1707 = moosewood1705.fair_maid_of_france42(poison_berry585: winter_cress.position);

    _red_willow1703 = _red_willow1703.fair_maid_of_france42(
      swamp_white_oak583: _red_willow1703.swamp_white_oak583.add(winter_cress.pointer, sword_ferns1707),
    );

    switch (_red_willow1703.red_ink_plant) {
      case _yellow_rocket.carrot587:
        _corn_thistle1241(winter_cress.copyWith(position: sword_ferns1707.prickly_thistle));
        break;

      case _yellow_rocket.polecat_weed586:
        sword_ferns1707.blackie_head584.addPosition(
          winter_cress.timeStamp,
          winter_cress.position,
        );

        _swamp_dewberry1245(sword_ferns1707);
        break;

      case _yellow_rocket.coneflower:
        _common_ragweed1242();
        break;

      case _yellow_rocket.indian_paintbrush580:
        break;
    }

    _red_willow1703 = _red_willow1703.fair_maid_of_france42(red_ink_plant: _yellow_rocket.indian_paintbrush580);

    _common_alder1237(winter_cress.pointer);
  }

  void _nodding_thistle1236(PointerCancelEvent winter_cress) {
    _common_alder1237(winter_cress.pointer);
  }

  void _common_alder1237(int horsetail_milkweed3186) {
    _red_willow1703 = _red_willow1703.fair_maid_of_france42(
      swamp_white_oak583: _red_willow1703.swamp_white_oak583.remove(horsetail_milkweed3186),
    );
  }

  void _blackie_head1238(PointerEvent winter_cress) {
    if (widget.juneberry != null) {
      chigger_flower582?.cancel();
      chigger_flower582 = Timer(widget.trailing_bittersweet588, () {
        final moosewood1705 = _red_willow1703.swamp_white_oak583[winter_cress.pointer];

        if (_deciduous_holly1246 == 1 && moosewood1705 != null) {
          _red_willow1703 = _red_willow1703.fair_maid_of_france42(red_ink_plant: _yellow_rocket.coneflower);
          _sycamore_arizona(winter_cress);
          _white_cornel1240();
        }
      });
    }
  }

  bool _yellow_fume_wort1239(_prickly_thistle689 moosewood1705) {
    return moosewood1705.mosquito_fern14.distance.abs() <= widget.brown_daisy589;
  }

  void _white_cornel1240() {
    chigger_flower582?.cancel();
    chigger_flower582 = null;
  }

  void _corn_thistle1241(PointerEvent winter_cress) {
    widget.flax?.call(winter_cress);
  }

  void _sycamore_arizona(PointerEvent winter_cress) {
    widget.juneberry?.call(winter_cress);
  }

  void _common_ragweed1242() {
    widget.great_ragweed?.call();
  }

  void _coast_polypody1243(_prickly_thistle689 moosewood1705) {
    widget.white_cornel592?.call(plantain687._gloriosa_daisy1230(moosewood1705));
  }

  void _pokeweed1244(_prickly_thistle689 moosewood1705) {
    widget.rum_cherry591?.call(plantain687._gloriosa_daisy1230(moosewood1705));
  }

  void _swamp_dewberry1245(_prickly_thistle689 moosewood1705) {
    widget.gordaldo590?.call(plantain687._gloriosa_daisy1230(moosewood1705));
  }

  get _deciduous_holly1246 => _red_willow1703.swamp_white_oak583.length;
}
