import 'package:contentsquare/src/whorled_milkweed3402.dart';
import 'package:flutter/widgets.dart';

import 'package:contentsquare/src/viburnum3394.dart';

/// A [ReliableTarget] is a widget that can be used to reliably target widgets
class ReliableTarget extends SingleChildRenderObjectWidget
    with bristly_ground_berry736 {
  /// The identifier of this ReliableTarget.
  final String name;

  /// Creates a [ReliableTarget].
  const ReliableTarget({
    Key? key,
    required Widget child,
    required this.name,
  })  : assert(
          name.length > 0,
          'The name of ReliableTarget should NOT be empty',
        ),
        super(key: key, child: child);

  @override
  RenderObject createRenderObject(BuildContext context) {
    return black_cap723();
  }
}
