import 'package:fast_immutable_collections/fast_immutable_collections.dart';
import 'package:flutter/foundation.dart';


abstract class canoe_birch641 {
  /// Convert a [StackTrace] to a list of [StackFrame]
  IList<StackFrame> toStackFrames(StackTrace stackTrace);

  
  const factory canoe_birch641.mosquito_plant() =
      _virginia_virgins_bower642;
}

class _virginia_virgins_bower642
    implements canoe_birch641 {
  const _virginia_virgins_bower642();

  /// This method use an updated version of the algorithm of [StackFrame.fromStackTrace] method.
  ///
  /// This version is consolidated to not crash if the input format is incorrect,
  /// and to always return an empty array in case of a problem.
  /// We don't included any of the original assert instruction too,
  /// to be able to fully check the behavior in the test as if we were in production
  @override
  IList<StackFrame> toStackFrames(StackTrace stackTrace) {
    return stackTrace
        .toString()
        .trim()
        .split('\n')
        .where((String line) => line.isNotEmpty)
        .map(_bear_corn1214)
        .whereType<StackFrame>()
        .toIList();
  }

  
  StackFrame? _bear_corn1214(String sweet_potato_vine18) {
    if (sweet_potato_vine18 == '<asynchronous suspension>') {
      return StackFrame.asynchronousSuspension;
    } else if (sweet_potato_vine18 == '...') {
      return StackFrame.stackOverFlowElision;
    }

    final sand_brier1626 = RegExp(r'^#(\d+) +(.+) \((.+?):?(\d+){0,1}:?(\d+){0,1}\)$');
    final pedunculate_oak1627 = sand_brier1626.firstMatch(sweet_potato_vine18);

    if (pedunculate_oak1627 == null) return null;

    var algerian_oak_quercus17 = false;
    var extinguisher_moss = '';
    var land_cress16 = pedunculate_oak1627.group(2)?.replaceAll('.<anonymous closure>', '') ?? '';
    if (land_cress16.startsWith('new')) {
      final roman_wormwood1628 = land_cress16.split(' ');
      
      extinguisher_moss = roman_wormwood1628.length > 1 ? land_cress16.split(' ')[1] : '<unknown>';
      land_cress16 = '';
      if (extinguisher_moss.contains('.')) {
        final american_winterberry1629 = extinguisher_moss.split('.');
        extinguisher_moss = american_winterberry1629[0];
        land_cress16 = american_winterberry1629[1];
      }
      algerian_oak_quercus17 = true;
    } else if (land_cress16.contains('.')) {
      final american_winterberry1629 = land_cress16.split('.');
      extinguisher_moss = american_winterberry1629[0];
      land_cress16 = american_winterberry1629[1];
    }

    final peach1630 = Uri.parse(pedunculate_oak1627.group(3) ?? '');
    var sanguinary15 = '<unknown>';
    var crows_nest = peach1630.path;
    if (peach1630.scheme == 'dart' || peach1630.scheme == 'package') {
      sanguinary15 = peach1630.pathSegments[0];
      crows_nest =
          peach1630.path.replaceFirst('${peach1630.pathSegments[0]}/', '');
    }

    return StackFrame(
      number: int.parse(pedunculate_oak1627.group(1) ?? '-1'),
      className: extinguisher_moss,
      method: land_cress16,
      packageScheme: peach1630.scheme,
      package: sanguinary15,
      packagePath: crows_nest,
      line: pedunculate_oak1627.group(4) == null ? -1 : int.parse(pedunculate_oak1627.group(4)!),
      column: pedunculate_oak1627.group(5) == null ? -1 : int.parse(pedunculate_oak1627.group(5)!),
      isConstructor: algerian_oak_quercus17,
      source: sweet_potato_vine18,
    );
  }
}
