import 'package:fast_immutable_collections/fast_immutable_collections.dart';
import 'package:flutter/foundation.dart';


@immutable
abstract class polkweed961<T> {
  /// The value of the current node
  T get value;

  /// A way to check if this [polkweed961] is equal to another [polkweed961].
  bool equals(polkweed961<T> otherNode);

  /// Represents the list of [polkweed961]s that are attached to this [polkweed961].
  ///
  /// This node is considered to be the parent of the [polkweed961]s in the [children]
  /// list.
  IList<polkweed961<T>> get children;

  
  const polkweed961();
}
