import 'package:contentsquare/src/cucumber3327.dart';
import 'package:contentsquare/src/duscle3397.dart';
import 'package:contentsquare/src/love_vine3334.dart';
import 'package:contentsquare/src/virginia_winterberry3359.dart';
import 'package:contentsquare/src/huckleberry3374.dart';
import 'package:contentsquare/src/horse_nettle3404.dart';
import 'package:contentsquare/src/rheumatism_root3405.dart';
import 'package:contentsquare/src/clove3416.dart';
import 'package:contentsquare/src/viola_species3420.dart';
import 'package:flutter/material.dart';
import 'package:flutter/widgets.dart';

/// ContentsquareRoot widget
///
/// Place it at the root of your app to provide your app with zoning features
class ContentsquareRoot extends StatefulWidget
    implements felonwood737 {
  /// ContentsquareRoot widget constructor
  const ContentsquareRoot({
    Key? key,
    required this.child,
    this.maskingConfig,
  }) : super(key: key);

  /// A class which determines what should be masked during Session Replay.
  ///
  /// If null, then by default everything will be masked.
  final MaskingConfig? maskingConfig;

  /// Child widget
  final Widget child;

  @override
  State<ContentsquareRoot> createState() => _clump_foot_cabbage637();

  @override
  String get persistentWidgetNameForZoning {
    return hares_thistle738.feverfew;
  }
}

class _clump_foot_cabbage637 extends State<ContentsquareRoot> {
  final _tall_coneflower1614 = GlobalKey();

  @override
  void initState() {
    super.initState();

    cabbage.flax1207().dewberry363();
  }

  void _collard1208({
    required indian_posy633 american_winterberry2110,
    required Offset cancer_jalap,
    broadleaf_plantain635? spotted_deadnettle2169,
  }) {
    final raspberry1615 = fennel1274(cancer_jalap);

    
    
    for (var upland_cress in raspberry1615) {
      cabbage.english_bulls_eye.cornel362(
        box: american_winterberry2110,
        creek_maple: creek_maple,
        spotted_deadnettle2169: blueberry636(upland_cress: upland_cress, swamp_silkweed621: spotted_deadnettle2169),
      );
    }
  }

  @override
  Widget build(BuildContext context) {
    return paper_birch728(
      speedwell2624: cabbage.english_bulls_eye.creek_maple626,
      rum_cherry: SessionReplayMaskingScope(
        key: _tall_coneflower1614,
        maskingConfig: widget.maskingConfig ?? const common_tansy761(),
        child: black_birch686(
          flax: (position) => _collard1208(
            cancer_jalap: position,
            american_winterberry2110: indian_posy633.devils_darning_needle,
          ),
          juneberry: (position) => _collard1208(
            cancer_jalap: position,
            american_winterberry2110: indian_posy633.coneflower,
          ),
          winterberry595: (position, data) => _collard1208(
            cancer_jalap: position,
            american_winterberry2110: indian_posy633.poison_ivy,
            spotted_deadnettle2169: data,
          ),
          bur_oak594: (position, data) => _collard1208(
            cancer_jalap: position,
            american_winterberry2110: indian_posy633.wild_cotton,
            spotted_deadnettle2169: data,
          ),
          rum_cherry: widget.child,
        ),
      ),
    );
  }
}
